.form-control {
  @height: calc(var(--font-size) * var(--line-height) + 1rem + 2px);

  background-color: var(--form-bg);
  border: solid 1px var(--border);
  border-radius: 0; // disable rounded corners on iOS
  color: var(--text);
  display: inline-block;
  font-size: var(--font-size);
  min-height: @height;
  padding: 0.5rem;
  transition: background-color .1s, box-shadow .1s, border-color .1s, color .1s;

  // work around bug that occurs in chrome (and safari?) when parent line-height
  // is less than the widget's, making the <select> text disappear
  line-height: var(--line-height);

  @supports (-webkit-overflow-scrolling: touch) {
    // fix zoom-on-focus in iOS
    --font-size: ~'max(16px, var(--font-size))';
    --font-size: 16px;
  }

  input&:not([type]),
  &[type="text"],
  &[type="password"],
  &[type="email"],
  &[type="url"],
  &[type="search"],
  &[type="date"],
  &[type="time"],
  &[type="checkbox"],
  &[type="radio"],
  textarea& {
    // remove ugly shade on iOS, and disable native styling for checkbox/radio
    -webkit-appearance: none;
  }

  input&:not([type]),
  &[type="text"],
  &[type="password"],
  &[type="email"],
  &[type="url"],
  &[type="search"],
  &[type="file"] {
    max-width: 100%;

    &:not([size]) {
      width: 100%;
    }
  }

  &[type="date"],
  &[type="time"] {
    min-width: 5rem; // fix for iOS
  }

  // should only be used in combination with .unstylable-widget. leave
  // .form-control off otherwise.
  &[type="checkbox"],
  &[type="radio"] {
    min-height: unset;
  }

  &[type="radio"] {
    border-radius: 50%;
  }

  &[type="file"] {
    cursor: pointer;
  }

  textarea& {
    max-width: 100%;
    resize: vertical;

    &:not([cols]) {
      width: 100%;
    }
  }

  select&:not([multiple]) {
    height: @height; // dropdown caret doesn't acknowledge min-height

    // having vertical padding cuts off the text inside. having height set is
    // enough to achieve a padding effect.
    padding-top: 0;
    padding-bottom: 0;
  }

  &:invalid {
    box-shadow: unset; // remove default browser style
  }

  &:focus {
    border-color: var(--primary);
    box-shadow: 0 0 2px 2px var(--primary-alpha);
    outline: none; // remove default browser style
  }

  &:disabled {
    background-color: var(--bg-grey);
    color: var(--fg-grey);
  }

  &[readonly]:focus {
    border-color: var(--border);
  }
}
